# frozen_string_literal: true

#--
# gravaty
# rubocop:disable Style/AsciiComments
# © 2013 Marco Bresciani
# rubocop:enable Style/AsciiComments
#
# This file is part of gravaty.
#
# gravaty is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation, either version 3 of the License, or (at your
# option) any later version.
#
# gravaty is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License
# along with gravaty. If not, see <http://www.gnu.org/licenses/>.
#
# SPDX-FileCopyrightText: 2013 Marco Bresciani
#
# SPDX-License-Identifier: GPL-3.0-or-later
#++

require_relative 'test_helper'

describe Gravaty::Gravaty do
  describe 'when passed a nil email address' do
    it 'must raise an argument error' do
      _(-> { Gravaty.gravatize nil }).must_raise ArgumentError
    end
  end

  describe 'when passed an invalid email address according to RF5322' do
    it 'must raise an argument error' do
      _(-> { Gravaty.gravatize '-.' }).must_raise ArgumentError
    end
  end

  describe 'when created with a valid email address' do
    subject { Gravaty.gravatize Gravaty::TEST_MY_ADDRESS }

    it 'must create a gravaty object' do
      _(subject).wont_be_nil
      _(subject).must_be_instance_of Gravaty::Gravaty
    end
  end
end
